// This file was automatically generated. Do not edit this file!
#ifndef INITIALIZER_EXOTICA_IK_SOLVER_IK_SOLVER_INITIALIZER_H
#define INITIALIZER_EXOTICA_IK_SOLVER_IK_SOLVER_INITIALIZER_H

#include <exotica_core/property.h>

namespace exotica
{
inline std::vector<Initializer> GetExoticaIkSolverInitializers();
}

namespace exotica
{

class IKSolverInitializer : public InitializerBase
{
public:
    static std::string GetContainerName() { return "exotica/IKSolver"; }

    IKSolverInitializer() : InitializerBase(),
        Debug( false) ,
        MaxIterations( 100) ,
        Tolerance( 1e-5) ,
        MaxStep( 0.0) ,
        RegularizationRate( 1e-9) ,
        MinimumRegularization( 1e-12) ,
        MaximumRegularization( 1e9) ,
        ThresholdRegularizationIncrease( 0.1) ,
        ThresholdRegularizationDecrease( 0.5) ,
        GradientToleranceConvergenceThreshold( 1e-9) ,
        StepToleranceConvergenceThreshold( 1e-5) 
    {
    }

    IKSolverInitializer( std::string _Name, bool _Debug =  false, int _MaxIterations =  100, double _Tolerance =  1e-5, double _MaxStep =  0.0, double _RegularizationRate =  1e-9, double _MinimumRegularization =  1e-12, double _MaximumRegularization =  1e9, double _ThresholdRegularizationIncrease =  0.1, double _ThresholdRegularizationDecrease =  0.5, double _GradientToleranceConvergenceThreshold =  1e-9, double _StepToleranceConvergenceThreshold =  1e-5) : InitializerBase(),
        Name(_Name) ,
        Debug(_Debug) ,
        MaxIterations(_MaxIterations) ,
        Tolerance(_Tolerance) ,
        MaxStep(_MaxStep) ,
        RegularizationRate(_RegularizationRate) ,
        MinimumRegularization(_MinimumRegularization) ,
        MaximumRegularization(_MaximumRegularization) ,
        ThresholdRegularizationIncrease(_ThresholdRegularizationIncrease) ,
        ThresholdRegularizationDecrease(_ThresholdRegularizationDecrease) ,
        GradientToleranceConvergenceThreshold(_GradientToleranceConvergenceThreshold) ,
        StepToleranceConvergenceThreshold(_StepToleranceConvergenceThreshold) 
    {
    }

    IKSolverInitializer(const Initializer& other) : IKSolverInitializer()
    {
        if (other.HasProperty("Name")) { const Property& prop = other.properties_.at("Name"); if(prop.IsSet()) {Name = boost::any_cast<std::string>(prop.Get());} }
        if (other.HasProperty("Debug")) { const Property& prop = other.properties_.at("Debug"); if(prop.IsSet()) {Debug = prop.IsStringType()?ParseBool(boost::any_cast<std::string>(prop.Get())):boost::any_cast<bool>(prop.Get());} }
        if (other.HasProperty("MaxIterations")) { const Property& prop = other.properties_.at("MaxIterations"); if(prop.IsSet()) {MaxIterations = prop.IsStringType()?ParseInt(boost::any_cast<std::string>(prop.Get())):boost::any_cast<int>(prop.Get());} }
        if (other.HasProperty("Tolerance")) { const Property& prop = other.properties_.at("Tolerance"); if(prop.IsSet()) {Tolerance = prop.IsStringType()?ParseDouble(boost::any_cast<std::string>(prop.Get())):boost::any_cast<double>(prop.Get());} }
        if (other.HasProperty("MaxStep")) { const Property& prop = other.properties_.at("MaxStep"); if(prop.IsSet()) {MaxStep = prop.IsStringType()?ParseDouble(boost::any_cast<std::string>(prop.Get())):boost::any_cast<double>(prop.Get());} }
        if (other.HasProperty("RegularizationRate")) { const Property& prop = other.properties_.at("RegularizationRate"); if(prop.IsSet()) {RegularizationRate = prop.IsStringType()?ParseDouble(boost::any_cast<std::string>(prop.Get())):boost::any_cast<double>(prop.Get());} }
        if (other.HasProperty("MinimumRegularization")) { const Property& prop = other.properties_.at("MinimumRegularization"); if(prop.IsSet()) {MinimumRegularization = prop.IsStringType()?ParseDouble(boost::any_cast<std::string>(prop.Get())):boost::any_cast<double>(prop.Get());} }
        if (other.HasProperty("MaximumRegularization")) { const Property& prop = other.properties_.at("MaximumRegularization"); if(prop.IsSet()) {MaximumRegularization = prop.IsStringType()?ParseDouble(boost::any_cast<std::string>(prop.Get())):boost::any_cast<double>(prop.Get());} }
        if (other.HasProperty("ThresholdRegularizationIncrease")) { const Property& prop = other.properties_.at("ThresholdRegularizationIncrease"); if(prop.IsSet()) {ThresholdRegularizationIncrease = prop.IsStringType()?ParseDouble(boost::any_cast<std::string>(prop.Get())):boost::any_cast<double>(prop.Get());} }
        if (other.HasProperty("ThresholdRegularizationDecrease")) { const Property& prop = other.properties_.at("ThresholdRegularizationDecrease"); if(prop.IsSet()) {ThresholdRegularizationDecrease = prop.IsStringType()?ParseDouble(boost::any_cast<std::string>(prop.Get())):boost::any_cast<double>(prop.Get());} }
        if (other.HasProperty("GradientToleranceConvergenceThreshold")) { const Property& prop = other.properties_.at("GradientToleranceConvergenceThreshold"); if(prop.IsSet()) {GradientToleranceConvergenceThreshold = prop.IsStringType()?ParseDouble(boost::any_cast<std::string>(prop.Get())):boost::any_cast<double>(prop.Get());} }
        if (other.HasProperty("StepToleranceConvergenceThreshold")) { const Property& prop = other.properties_.at("StepToleranceConvergenceThreshold"); if(prop.IsSet()) {StepToleranceConvergenceThreshold = prop.IsStringType()?ParseDouble(boost::any_cast<std::string>(prop.Get())):boost::any_cast<double>(prop.Get());} }
    }

    virtual ~IKSolverInitializer()
    {
    }

    virtual Initializer GetTemplate() const
    {
        return (Initializer)IKSolverInitializer();
    }

    virtual std::vector<Initializer> GetAllTemplates() const
    {
        return GetExoticaIkSolverInitializers();
    }

    virtual void Check(const Initializer& other) const
    {
        if(!other.HasProperty("Name") || !other.properties_.at("Name").IsSet()) ThrowPretty("Initializer IKSolverInitializer requires property Name to be set!");
    }

    operator Initializer()
    {
        Initializer ret(GetContainerName());
        ret.properties_.emplace("Name", Property("Name", true, boost::any(Name)));
        ret.properties_.emplace("Debug", Property("Debug", false, boost::any(Debug)));
        ret.properties_.emplace("MaxIterations", Property("MaxIterations", false, boost::any(MaxIterations)));
        ret.properties_.emplace("Tolerance", Property("Tolerance", false, boost::any(Tolerance)));
        ret.properties_.emplace("MaxStep", Property("MaxStep", false, boost::any(MaxStep)));
        ret.properties_.emplace("RegularizationRate", Property("RegularizationRate", false, boost::any(RegularizationRate)));
        ret.properties_.emplace("MinimumRegularization", Property("MinimumRegularization", false, boost::any(MinimumRegularization)));
        ret.properties_.emplace("MaximumRegularization", Property("MaximumRegularization", false, boost::any(MaximumRegularization)));
        ret.properties_.emplace("ThresholdRegularizationIncrease", Property("ThresholdRegularizationIncrease", false, boost::any(ThresholdRegularizationIncrease)));
        ret.properties_.emplace("ThresholdRegularizationDecrease", Property("ThresholdRegularizationDecrease", false, boost::any(ThresholdRegularizationDecrease)));
        ret.properties_.emplace("GradientToleranceConvergenceThreshold", Property("GradientToleranceConvergenceThreshold", false, boost::any(GradientToleranceConvergenceThreshold)));
        ret.properties_.emplace("StepToleranceConvergenceThreshold", Property("StepToleranceConvergenceThreshold", false, boost::any(StepToleranceConvergenceThreshold)));
        return ret;
    }

    std::string Name;
    bool Debug;
    int MaxIterations;
    double Tolerance;
    double MaxStep;
    double RegularizationRate;
    double MinimumRegularization;
    double MaximumRegularization;
    double ThresholdRegularizationIncrease;
    double ThresholdRegularizationDecrease;
    double GradientToleranceConvergenceThreshold;
    double StepToleranceConvergenceThreshold;
};

}

#include <exotica_ik_solver/exotica_ik_solver_initializers_numerator.h>


#endif